﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MyWpfApp.models
{
    /// <summary>
    /// источник данных для страницы UserInfo
    /// </summary>
    public class User
    {        
        //создаем объекты тех таблиц БД, с которыми необходмо работать (брать или добавлять данные)
        UserTable userTable;
        LoginedTable loginedTable;

        /// <summary>
        /// конструктор, который принимает аргумент. используется, если мы редактируем существующего пользователя
        /// </summary>
        /// <param name="loginedTable">Инфо о текущем пользователе</param>
        public User(LoginedTable loginedTable)
        {
            this.loginedTable = loginedTable;
            userTable = Globals.MyGlobalConnection.UserTable.FirstOrDefault(x => x.ID == loginedTable.ID);
        }
        /// <summary>
        /// конструктор без аргументов. Используется, если мы создаем нового пользователя
        /// </summary>
         public User()
        {
            loginedTable = new LoginedTable();
            userTable = new UserTable();  
        }

        /// <summary>
        /// свойство для пароля. переводит его строковое значение в хеш-код
        /// </summary>
        public string Password { set=> loginedTable.Password=value.GetHashCode(); }
        /// <summary>
        /// в get реализуется связь 1 к 1.
        /// </summary>
        public UserTable UserTable { get { userTable.ID = loginedTable.ID; return userTable; } set => userTable = value; }
        public LoginedTable LoginedTable { get => loginedTable; set => loginedTable = value; }
    }
}
